Utilities
Collaboration diagram for Utilities:

## Modules

| Function Objects
| Memory
| Metaprogramming
| Rational Arithmetic
| Time

## Classes

struct | std::_Tuple_impl< _Idx, _Elements >
struct | std::_Tuple_impl< _Idx >
struct | std::_Tuple_impl< _Idx, _Head, _Tail...>
struct | std::pair< _T1, _T2 >
struct | std::piecewise_construct_t
class | std::tuple< _Elements >
class | std::tuple< _T1, _T2 >
class | std::tuple_element< _Int, _Tp >
struct | std::tuple_element< 0, tuple< _Head, _Tail...> >
struct | std::tuple_element< __i, tuple< _Head, _Tail...> >
class | std::tuple_size< _Tp >
struct | std::tuple_size< tuple< _Elements...> >
struct | std::type_index
struct | std::uses_allocator< tuple< _Types...>, _Alloc >

## Typedefs

template<typename _Tp >
using | std::__empty_not_final = typename conditional< __is_final(_Tp), false_type, __is_empty_non_tuple< _Tp >>::type

## Functions

template<typename... _Args1, typename... _Args2>
| std::pair< _T1, _T2 >::pair (piecewise_construct_t, tuple< _Args1...>, tuple< _Args2...>)
template<typename _Tp >
_Tp * | std::__addressof (_Tp &__r) noexcept
template<std::size_t __i, typename _Head , typename... _Tail>
constexpr __add_ref< _Head >::type | std::__get_helper (_Tuple_impl< __i, _Head, _Tail...> &__t) noexcept
template<std::size_t __i, typename _Head , typename... _Tail>
constexpr __add_c_ref< _Head > ::type | std::__get_helper (const _Tuple_impl< __i, _Head, _Tail...> &__t) noexcept
template<typename _Tp >
_Tp * | std::addressof (_Tp &__r) noexcept
template<typename _Tp >
add_rvalue_reference< _Tp >::type | std::declval () noexcept
template<typename _Tp >
constexpr _Tp && | std::forward (typename std::remove_reference< _Tp >::type &__t) noexcept
template<typename _Tp >
constexpr _Tp && | std::forward (typename std::remove_reference< _Tp >::type &&__t) noexcept
template<typename... _Elements>
tuple< _Elements &&...> | std::forward_as_tuple (_Elements &&...__args) noexcept
template<std::size_t __i, typename... _Elements>
constexpr __add_ref< typename tuple_element< __i, tuple < _Elements...> >::type > ::type | std::get (tuple< _Elements...> &__t) noexcept
template<std::size_t __i, typename... _Elements>
constexpr __add_c_ref < typename tuple_element< __i, tuple< _Elements...> >::type > ::type | std::get (const tuple< _Elements...> &__t) noexcept
template<std::size_t __i, typename... _Elements>
constexpr __add_r_ref < typename tuple_element< __i, tuple< _Elements...> >::type > ::type | std::get (tuple< _Elements...> &&__t) noexcept
template<class _T1 , class _T2 >
constexpr pair< typename __decay_and_strip< _T1 > ::__type, typename __decay_and_strip< _T2 > ::__type > | std::make_pair (_T1 &&__x, _T2 &&__y)
template<typename... _Elements>
constexpr tuple< typename __decay_and_strip< _Elements > ::__type...> | std::make_tuple (_Elements &&...__args)
template<typename _Tp >
constexpr std::remove_reference< _Tp > ::type && | std::move (_Tp &&__t) noexcept
template<typename _Tp >
constexpr conditional < __move_if_noexcept_cond< _Tp > ::value, const _Tp &, _Tp && > ::type | std::move_if_noexcept (_Tp &__x) noexcept
template<class _T1 , class _T2 >
constexpr bool | std::operator!= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator!= (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
constexpr bool | std::operator< (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator< (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
constexpr bool | std::operator<= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator<= (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
constexpr bool | std::operator== (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator== (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
constexpr bool | std::operator> (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator> (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
constexpr bool | std::operator>= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator>= (const tuple< _TElements...> &__t, const tuple< _UElements...> &__u)
template<class _T1 , class _T2 >
void | std::swap (pair< _T1, _T2 > &__x, pair< _T1, _T2 > &__y) noexcept(noexcept(__x.swap(__y)))
template<typename _Tp >
void | std::swap (_Tp &__a, _Tp &__b) noexcept(__and_< is_nothrow_move_constructible< _Tp >,is_nothrow_move_assignable< _Tp >>::value)
template<typename _Tp , size_t _Nm>
void | std::swap (_Tp(&__a)[_Nm], _Tp(&__b)[_Nm]) noexcept(noexcept(swap(*__a,*__b)))
template<typename... _Elements>
void | std::swap (tuple< _Elements...> &__x, tuple< _Elements...> &__y) noexcept(noexcept(__x.swap(__y)))
template<typename... _Elements>
tuple< _Elements &...> | std::tie (_Elements &...__args) noexcept
template<typename... _Tpls, typename = typename enable_if<__and_<__is_tuple_like<_Tpls>...>::value>::type>
constexpr auto | std::tuple_cat (_Tpls &&...__tpls) -> typename __tuple_cat_result< _Tpls...>::__type

## Variables

const _Swallow_assign | std::ignore
constexpr piecewise_construct_t | std::piecewise_construct

## Detailed Description

Components deemed generally useful. Includes pair, tuple, forward/move helpers, ratio, function object, metaprogramming and type traits, time, date, and memory functions.

## Function Documentation

template<typename _Tp >

_Tp* std::__addressof | ( | _Tp & | __r | ) |

inline noexcept

Same as C++11 std::addressof.

Definition at line 47 of file move.h.

Referenced by std::addressof(), std::begin(), std::vector< _State >::data(), std::end(), std::forward_list< _Tp, _Alloc >::remove(), and std::list< _Tp, _Alloc >::remove().

template<typename _Tp >

_Tp* std::addressof | ( | _Tp & | __r | ) |

inline noexcept

Returns the actual address of the object or function referenced by r, even in the presence of an overloaded operator&.

Parameters

  __r | Reference to an object or function.

Returns
  The actual address.

Definition at line 135 of file move.h.

References std::__addressof().

Referenced by std::pointer_traits< _Tp * >::pointer_to().

template<typename _Tp >

add_rvalue_reference< _Tp >::type std::declval | ( |  | ) |

inline noexcept

Utility to simplify expressions used in unevaluated operands.

Definition at line 1869 of file type_traits.

template<typename _Tp >

constexpr _Tp&& std::forward | ( | typename std::remove_reference< _Tp >::type & | __t | ) |

noexcept

Forward an lvalue.

Returns
  The parameter cast to the specified type.

This function is used to implement "perfect forwarding".

Definition at line 76 of file move.h.

template<typename _Tp >

constexpr _Tp&& std::forward | ( | typename std::remove_reference< _Tp >::type && | __t | ) |

noexcept

Forward an rvalue.

Returns
  The parameter cast to the specified type.

This function is used to implement "perfect forwarding".

Definition at line 87 of file move.h.

template<class _T1 , class _T2 >

constexpr pair<typename __decay_and_strip<_T1>::__type, typename __decay_and_strip<_T2>::__type> std::make_pair | ( | _T1 && | __x,
|  | _T2 && | __y
| ) |  |

A convenience wrapper for creating a pair from two objects.

Parameters

  __x | The first object.
  __y | The second object.

Returns
  A newly-constructed pair<> object of the appropriate type.

The standard requires that the objects be passed by reference-to-const, but LWG issue #181 says they should be passed by const value. We follow the LWG by default.

Definition at line 276 of file stl_pair.h.

Referenced by __gnu_parallel::__find_template(), __gnu_debug::__get_distance(), __gnu_parallel::__parallel_merge_advance(), __gnu_parallel::__parallel_sort_qsb(), __gnu_parallel::__qsb_local_sort_with_helping(), __gnu_parallel::__find_if_selector::_M_sequential_algorithm(), __gnu_parallel::__adjacent_find_selector::_M_sequential_algorithm(), __gnu_parallel::__find_first_of_selector< _FIterator >::_M_sequential_algorithm(), std::minmax_element(), __gnu_parallel::multiseq_partition(), __gnu_parallel::multiseq_selection(), __gnu_parallel::parallel_multiway_merge(), __gnu_parallel::parallel_sort_mwms_pu(), and __gnu_pbds::detail::pat_trie_base::_Node_citer< Node, Leaf, Head, Inode, _CIterator, Iterator, _Alloc >::valid_prefix().

template<typename _Tp >

constexpr std::remove_reference<_Tp>::type&& std::move | ( | _Tp && | __t | ) |

noexcept

Convert a value to an rvalue.

Parameters

  __t | A thing of arbitrary type.

Returns
  The parameter cast to an rvalue-reference to allow moving it.

Definition at line 101 of file move.h.

template<typename _Tp >

constexpr conditional<__move_if_noexcept_cond<_Tp>::value, const _Tp&, _Tp&&>::type std::move_if_noexcept | ( | _Tp & | __x | ) |

inline noexcept

Conditionally convert a value to an rvalue.

Parameters

  __x | A thing of arbitrary type.

Returns
  The parameter, possibly cast to an rvalue-reference.

Same as std::move unless the type's move constructor could throw and the type is copyable, in which case an lvalue-reference is returned instead.

Definition at line 121 of file move.h.

template<class _T1 , class _T2 >

constexpr bool std::operator!= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

Uses `operator==` to find the result.

Definition at line 227 of file stl_pair.h.

template<class _T1 , class _T2 >

constexpr bool std::operator< | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

http://gcc.gnu.org/onlinedocs/libstdc++/manual/utilities.html

Definition at line 220 of file stl_pair.h.

References std::pair< _T1, _T2 >::first.

template<class _T1 , class _T2 >

constexpr bool std::operator<= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

Uses `operator<` to find the result.

Definition at line 239 of file stl_pair.h.

template<class _T1 , class _T2 >

constexpr bool std::operator== | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

Two pairs of the same type are equal iff their members are equal.

Definition at line 214 of file stl_pair.h.

References std::pair< _T1, _T2 >::first, and std::pair< _T1, _T2 >::second.

template<class _T1 , class _T2 >

constexpr bool std::operator> | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

Uses `operator<` to find the result.

Definition at line 233 of file stl_pair.h.

template<class _T1 , class _T2 >

constexpr bool std::operator>= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

inline

Uses `operator<` to find the result.

Definition at line 245 of file stl_pair.h.

template<class _T1 , class _T2 >

void std::swap | ( | pair< _T1, _T2 > & | __x,
|  | pair< _T1, _T2 > & | __y
| ) |  |

inline noexcept

See std::pair::swap().

Definition at line 254 of file stl_pair.h.

template<typename _Tp >

void std::swap | ( | _Tp & | __a,
|  | _Tp & | __b
| ) |  | const

inline noexcept

Swaps two values.

Parameters

  __a | A thing of arbitrary type.
  __b | Another thing of arbitrary type.

Returns
  Nothing.

Definition at line 166 of file move.h.

template<typename _Tp , size_t _Nm>

void std::swap | ( | _Tp(&) | __a[_Nm],
|  | _Tp(&) | __b[_Nm]
| ) |  |

inline noexcept

Swap the contents of two arrays.

Definition at line 185 of file move.h.

template<typename... _Elements>

void std::swap | ( | tuple< _Elements...> & | __x,
|  | tuple< _Elements...> & | __y
| ) |  |

inline noexcept

swap

Definition at line 1048 of file tuple.

template<typename... _Elements>

tuple<_Elements&...> std::tie | ( | _Elements &... | __args | ) |

inline noexcept

tie

Definition at line 1042 of file tuple.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::lock(), and std::try_lock().

template<typename... _Tpls, typename = typename enable_if<__and_<__is_tuple_like<_Tpls>...>::value>::type>

constexpr auto std::tuple_cat | ( | _Tpls &&... | __tpls | ) | -> typename __tuple_cat_result<_Tpls...>::__type

tuple_cat

Definition at line 1030 of file tuple.

## Variable Documentation

constexpr piecewise_construct_t std::piecewise_construct

piecewise_construct

Definition at line 79 of file stl_pair.h.

Referenced by std::map< _Key, _Tp, _Compare, _Alloc >::operator[]().